'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 10 July 2008 at 11:05:43 am'!

!OldSimpleClientSocket class methodsFor: 'remote cursor example' stamp: 'jmv 7/10/2008 10:53'!
remoteCursorReceiver
	"Wait for a connection, then display data sent by the client until the client closes the stream. This server process is usually started first (optionally in a forked process), then the sender process is started (optionally on another machine). Note this machine's address, which is printed in the transcript, since the sender process will ask for it."
	"[OldSimpleClientSocket remoteCursorReceiver] fork"

	| sock response ary oldCursor |
	Transcript show: 'starting remote cursor receiver'; cr.
	Transcript show: 'initializing network'; cr.
	Socket initializeNetwork.
	Transcript show: 'my address is ', NetNameResolver localAddressString; cr.
	Transcript show: 'opening connection'; cr.
	sock _ OldSimpleClientSocket new.
	sock listenOn: 54323.
	sock waitForConnectionUntil: (Socket deadlineSecs: 60).
	sock isConnected
		ifFalse: [
			 sock destroy.
			Transcript show: 'remote cursor receiver did not receive a connection in 60 seconds; aborting.'.
			^ self].
	Transcript show: 'connection established'; cr.
	oldCursor _ ActiveHand temporaryCursor.
	ActiveHand showTemporaryCursor: Cursor normal.
	[sock isConnected]
		whileTrue: [
			sock dataAvailable
				ifTrue: [
					response _ sock getResponse.
					ary _ Compiler evaluate: response.
					Sensor processEvent: ary.
					ActiveHand temporaryCursor isNil ifTrue: [
						ActiveHand showTemporaryCursor: Cursor normal]
					]
				ifFalse: [
					"if no data available, let other processes run for a while"
					(Delay forMilliseconds: 20) wait]].

	sock destroy.
	Transcript show: 'remote cursor receiver done'; cr.
	ActiveHand showTemporaryCursor: oldCursor
! !

